
#ifndef RING_H
#define RING_H

#include <stdint.h>

struct ring {
	uint8_t *data;
	uint_fast8_t mask;
	volatile uint_fast8_t begin;
	volatile uint_fast8_t end;
};

void ring_init(struct ring *ring, uint8_t *buf, int size);
int ring_write_ch(struct ring *ring, uint8_t ch);
int ring_read_ch(struct ring *ring);
int_fast8_t ring_is_empty(struct ring *ring);

#endif /* RING_H */

